function r=SpikeSlab_givenZqR2(y,x,u,M,N,zstar,gam2star);

if isempty(u); l=0; else; l=size(u,2); end;
[T,k]=size(x);
varx=var(x(:,1),1);

% storage and preliminary calculations
if l>0; store_phi=zeros(l,M); end
store_B=zeros(k,M);
store_s2=zeros(M,1);

xx=x'*x; xy=x'*y; yx=y'*x; yy=y'*y;
if l>0; xu=x'*u; yu=y'*u; uu=u'*u; invuu=u'*u\eye(l); cholinvuu=chol(invuu); ux=u'*x; invuuuy=invuu*u'*y; invuuux=invuu*u'*x;
elseif l==0; xu=zeros(k,1); yu=zeros(1,1); uu=zeros(1,1); ux=zeros(1,k); phi=0; end

tau=sum(1-zstar);
W=xx(logical(1-zstar),logical(1-zstar))+eye(tau)/gam2star;

% starting values (Ridge using z)
if l>0; phi0=invuuuy; resy=y-u*phi0; store_phi(:,1)=phi0; else; resy=y; end
omegainv=eye(sum(1-zstar))/gam2star;
b0=(x(:,logical(1-zstar))'*x(:,logical(1-zstar))+omegainv)\(x(:,logical(1-zstar))'*y);
store_B(logical(1-zstar),1)=b0; b=zeros(k,1); b(logical(1-zstar))=b0;
s2=sum((resy-x*b).^2)/T; store_s2(1)=s2;


% Gibbs sampling
for i=2:M
    if i==1000*floor(.001*i);
        i
    end
    
    gam=sqrt(gam2star);
    z=zstar;
    
    % draw phi
    if l>0;
        phihat=invuuuy-invuuux*store_B(:,i-1);
        Vphi=invuu*s2;
        phi=(randn(1,l)*sqrt(s2)*cholinvuu)'+phihat;
        %phi=mvnrnd(phihat,Vphi)';
        store_phi(:,i)=phi';
    end
            
    bhat=W\(xy(logical(1-z))-xu(logical(1-z),:)*phi);
    
    % draw s2
    niu = yy-2*yu*phi+phi'*uu*phi-bhat'*W*bhat;
    s2=1./gamrnd(T/2,2/niu);
    store_s2(i)=s2;
    
    % draw b
    b=(randn(1,tau)*chol(s2*eye(tau)/W))'+bhat;
    store_B(logical(1-z),i)=b;
    
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% processing the results
if l>0; r.store_phi=store_phi; end
r.store_B=store_B;
r.store_s2=store_s2;