close all
clear all
cd .. 
cd Simulations
addpath SimulationsCodes

filename = 'SimulBase_sim100_draws-100K_rho75.mat'
%resultsDir = 'SimulationsResults/NEWsimulations/'; %This is the folder containing the simulations obtained from new run of MainSimulBase.m saves the results
resultsDir = 'SimulationsResults/GLPsimulations/';  %This is the folder containing the simulations used in the paper

eval(['load ' resultsDir filename])


figure('Position', [0, 400, 800, 600]); 

quantile = .05;

%%% Revised 

Alpha = .66;
cont = 0;


for js =[1 2 4];% 1:length(ss)
    s = ss(js);
    
    for jR2y = 1:length(RR2y)
        R2y = RR2y(jR2y);
        
        for j = 1:size(Freq,4)
            [y,x,rsim] = SimulBase(T,k,s,R2y,rho,CurrSeed{js,jR2y,j});
            r=UnfeasibleLassoBCH(y,x,[],quantile,1-R2y);
            slasso(:,j) = sum(r.blassoUBCH~=0);
        end;
        
        
        cont = cont+1;
        
        Temp = squeeze(Freq(:,js,jR2y,:));
        
        [junk indmax]=max(Temp);
        subplot(3,3,cont)
                                
        mode_smooth = ksdensity(indmax/k,Bins,'support',[0,1.0001],'function','pdf');          
        

        % Plot spike-and-slab
        plot(Bins, mode_smooth, 'LineWidth', 2, 'Color', 1.25*[55,126,184]/255);
        axis([-.01 1 0 max(mode_smooth)*1.1])
        hold on
        
        
        % Plot lasso 
        yl = ylim;
        scatter(slasso/k, linspace(yl(1), yl(2), length(slasso)),...
             5, 'o', 'filled',  ...
            'MarkerFaceAlpha', Alpha, 'MarkerEdgeAlpha', Alpha,...
            'MarkerFaceColor', 'red')
        grid off
        box on
        
        if cont==1 | cont==2 | cont==3
            title(['Predictability: ',num2str(R2y*100),'%']);
        end
        
        if cont==1 | cont==4 | cont==7
            ylabel(['s = ',num2str(s)],'fontweight','bold');
        end
        
        xlabel('q')
         % Plot reference point
        temp     = Bins*NaN;
        [~,jj]   = min(abs(Bins-s/k));
        temp(jj) = mode_smooth(jj);
        plot(Bins, temp, 'Color','k', 'Marker', '*','LineWidth',1.5)
        set(gca,'FontSize',10)
        hold off

        
    end
end

rmpath SimulationsCodes
