clear all
close all

figure('Position', [0, 400, 800, 800]); 

cd ../Estimation/EstimationResults/GLPdraws; % This is the folder containing the posterior draws used in the paper
%cd ../Estimation/EstimationResults/NEWdraws; % This is the folder containing the posterior draws obtained using new runs of the estimation codes


% joint posterior of q and log(gamma)

% macro 1
load Macro1_PosteriorDraws.mat
if exist('store_z')==0;
    store_z=Z;
    store_q=Q';
    store_gam=sqrt(Gamma2)';
    intq=qq;
    N=0;
end;
Z=store_z(:,N+1:M)';
meanZ=mean(Z);

gridg = -4:0.005:-.5;
gridq = 0:.01:1;

[Gridg, Gridq] = meshgrid(gridg, gridq);
Grid                = [Gridg(:) Gridq(:)];

Temp = (2*gridq'*k*exp(2*gridg))./((gridq'*k*exp(2*gridg)+1).^2);
Fprior = reshape(Temp, size(Gridg));


f = ksdensity([log(store_gam(N+1:end)),store_q(N+1:end)], Grid);
        Fpost = reshape(f, size(Gridg));

subplot(3,2,1)        
contour(Gridg, Gridq, Fpost, 10,'-','LineWidth',2);
hold on
contour(Gridg, Gridq, Fprior,10,':','LineWidth',1);
hold off        
colormap(bone)
xlabel('log(\gamma)'); ylabel('q')
title('Macro 1')
legend('Posterior','Prior')

clear all

%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% macro 2
load Macro2_PosteriorDraws.mat
if exist('store_z')==0;
    store_z=Z;
    store_q=Q';
    store_gam=sqrt(Gamma2)';
    intq=qq;
    N=0;
end;
Z=store_z(:,N+1:M)';
meanZ=mean(Z);

gridg = -4:0.05:.5;
gridq = 0:.01:1;

[Gridg, Gridq] = meshgrid(gridg, gridq);
Grid                = [Gridg(:) Gridq(:)];

Temp = (2*gridq'*k*exp(2*gridg))./((gridq'*k*exp(2*gridg)+1).^2);
Fprior = reshape(Temp, size(Gridg));

f = ksdensity([log(store_gam(N+1:end)),store_q(N+1:end)], Grid);
        Fpost = reshape(f, size(Gridg));

subplot(3,2,2)        
contour(Gridg, Gridq, Fpost, 10,'-','LineWidth',2);
hold on
contour(Gridg, Gridq, Fprior,10,':','LineWidth',1);
hold off        
colormap(bone)
xlabel('log(\gamma)'); ylabel('q')
title('Macro 2')
%legend('Prior','Posterior')

clear all

%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% finance 1
load Finance1_PosteriorDraws.mat
if exist('store_z')==0;
    store_z=Z;
    store_q=Q';
    store_gam=sqrt(Gamma2)';
    intq=qq;
    N=0;
end;
Z=store_z(:,N+1:M)';
meanZ=mean(Z);

gridg = -4.5:0.05:2.5;
gridq = 0:.01:1;

[Gridg, Gridq] = meshgrid(gridg, gridq);
Grid                = [Gridg(:) Gridq(:)];

Temp = (2*gridq'*k*exp(2*gridg))./((gridq'*k*exp(2*gridg)+1).^2);
Fprior = reshape(Temp, size(Gridg));

f = ksdensity([log(store_gam(N+1:end)),store_q(N+1:end)], Grid);
        Fpost = reshape(f, size(Gridg));

subplot(3,2,3)        
contour(Gridg, Gridq, Fpost, 10,'-','LineWidth',2);
hold on
contour(Gridg, Gridq, Fprior,10,':','LineWidth',1);
hold off        
colormap(bone)
xlabel('log(\gamma)'); ylabel('q')
title('Finance 1')
%legend('Prior','Posterior')
     
clear all

%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% finance 2
load Finance2_PosteriorDraws.mat
if exist('store_z')==0;
    store_z=Z;
    store_q=Q';
    store_gam=sqrt(Gamma2)';
    intq=qq;
    N=0;
end;
Z=store_z(:,N+1:M)';
meanZ=mean(Z);

gridg = -5.5:0.025:1;%-3.6;
gridq = 0:.01:1;

[Gridg, Gridq] = meshgrid(gridg, gridq);
Grid                = [Gridg(:) Gridq(:)];

Temp = (2*gridq'*k*exp(2*gridg))./((gridq'*k*exp(2*gridg)+1).^2);
Fprior = reshape(Temp, size(Gridg));

f = ksdensity([log(store_gam(N+1:end)),store_q(N+1:end)], Grid,'Bandwidth',[0.05 0.05]);
        Fpost = reshape(f, size(Gridg));

subplot(3,2,4)                
contour(Gridg, Gridq, Fpost, 10,'-','LineWidth',2);
hold on
contour(Gridg, Gridq, Fprior,10,':','LineWidth',1);
hold off        
colormap(bone)
xlabel('log(\gamma)'); ylabel('q')
title('Finance 2')
%legend('Prior','Posterior')
      
clear all

%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Micro 1
load Micro1_PosteriorDraws.mat
if exist('store_z')==0;
    store_z=Z;
    store_q=Q';
    store_gam=sqrt(Gamma2)';
    intq=qq;
    N=0;
end;
Z=store_z(:,N+1:M)';
meanZ=mean(Z);

gridg = -4:0.05:2;
gridq = 0:.001:.1;

[Gridg, Gridq] = meshgrid(gridg, gridq);
Grid                = [Gridg(:) Gridq(:)];

Temp = (2*gridq'*k*exp(2*gridg))./((gridq'*k*exp(2*gridg)+1).^2);
Fprior = reshape(Temp, size(Gridg));

[f,a,b] = ksdensity([log(store_gam(N+1:end)),store_q(N+1:end)], Grid);
        Fpost = reshape(f, size(Gridg));
  
subplot(3,2,5)        
contour(Gridg, Gridq, Fpost, 10,'-','LineWidth',2);
hold on
contour(Gridg, Gridq, Fprior,10,':','LineWidth',1);
hold off        
colormap(bone)
xlabel('log(\gamma)'); ylabel('q')
title('Micro 1')
%legend('Prior','Posterior')

clear all

%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Micro 2
load Micro2_PosteriorDraws.mat
if exist('store_z')==0;
    store_z=Z;
    store_q=Q';
    store_gam=sqrt(Gamma2)';
    intq=qq;
    N=0;
end;
Z=store_z(:,N+1:M)';
meanZ=mean(Z);

gridg = -4:0.05:1;
gridq = 0:.01:1;

[Gridg, Gridq] = meshgrid(gridg, gridq);
Grid                = [Gridg(:) Gridq(:)];

Temp = (2*gridq'*k*exp(2*gridg))./((gridq'*k*exp(2*gridg)+1).^2);
Fprior = reshape(Temp, size(Gridg));

f = ksdensity([log(store_gam(N+1:end)),store_q(N+1:end)], Grid);
        Fpost = reshape(f, size(Gridg));

subplot(3,2,6)        
contour(Gridg, Gridq, Fpost, 10,'-','LineWidth',2);
hold on
contour(Gridg, Gridq, Fprior,10,':','LineWidth',1);
hold off        
colormap(bone)
xlabel('log(\gamma)'); ylabel('q')
title('Micro 2')
%legend('Posterior','Prior')