clear all
close all

cd ../Estimation/EstimationResults/GLPdraws; % This is the folder containing the posterior draws used in the paper
%cd ../Estimation/EstimationResults/NEWdraws; % This is the folder containing the posterior draws obtained using new runs of the estimation codes

% marginal heatmaps
figure('Position', [0, 400, 800, 800]); 

% macro 1
load Macro1_PosteriorDraws.mat
if exist('store_z')==0;
    store_z=Z;
    store_q=Q';
    store_gam=sqrt(Gamma2)';
    intq=qq;
    N=0;
end;
Z=store_z(:,N+1:M)';
meanZ=mean(Z);

range=[0:.01:1];
meanZM=zeros(length(range)-1,k);
for j=1:length(range)-1
    Zj=Z(find(store_q(N+1:end)>range(j) & store_q(N+1:end)<range(j+1)),:);
    meanZM(j,:)=mean(Zj);
end

ax1=subplot(3,2,[1]);
imagesc(meanZM)
set(gca,'YDir','Normal','YAxisLocation','right')
colorbar('westoutside')
caxis([0, 1])
colormap(ax1,flipud(colormap(ax1,'hot')))
set(gca,'YTick',[range(1:20:end)*100],'YTickLabel',[range(1:20:end)]);
ylim([0 range(end)*100]);
ylabel('q')
xlabel('coefficients')
title('Macro 1')

[NoDraws]=histcounts([store_q(N+1:end)],range);
[junk posmax]=max(NoDraws);
%line([0 k+1],100*[range(posmax)+(range(posmax+1)-range(posmax))/2 range(posmax)+(range(posmax+1)-range(posmax))/2],'LineWidth',3);
line([0 k+1],100*[range(posmax)+(range(posmax+1)-range(posmax))/2 range(posmax)+(range(posmax+1)-range(posmax))/2],'LineWidth',3,'color','k');
line([0 k+1],100*[range(posmax)+(range(posmax+1)-range(posmax))/2 range(posmax)+(range(posmax+1)-range(posmax))/2],'LineWidth',3,'color','w','LineStyle','--');

clear all

% subplot(2,2,[2]); histogram([store_q(N+1:end)],range,'Normalization','pdf','Orientation','horizontal'); hold on;
% plot(betapdf(range,abeta,bbeta),range,'LineWidth',1.5)
% ylabel('q')
% xlabel('prior and posterior density')
% legend('posterior','prior','Location','northeast')
% title('Macro 1: flat hyperprior')
% ylim([0 1])
% clear all

%%%%%%%%%%%%%%%%%%%%%%%%
% macro 2
load Macro2_PosteriorDraws.mat
if exist('store_z')==0;
    store_z=Z;
    store_q=Q';
    store_gam=sqrt(Gamma2)';
    intq=qq;
    N=0;
end;
Z=store_z(:,N+1:M)';
meanZ=mean(Z);

range=[0:.01:1];
meanZM=zeros(length(range)-1,k);
for j=1:length(range)-1
    Zj=Z(find(store_q(N+1:end)>range(j) & store_q(N+1:end)<range(j+1)),:);
    meanZM(j,:)=mean(Zj);
end

ax1=subplot(3,2,[2]);
imagesc(meanZM)
set(gca,'YDir','Normal','YAxisLocation','right')
colorbar('westoutside')
caxis([0, 1])
colormap(ax1,flipud(colormap(ax1,'hot')))
set(gca,'YTick',[range(1:20:end)*100],'YTickLabel',[range(1:20:end)]);
ylim([0 range(end)*100]);
ylabel('q')
xlabel('coefficients')
title('Macro 2')

[NoDraws]=histcounts([store_q(N+1:end)],range);
[junk posmax]=max(NoDraws);
%line([0 k+1],100*[range(posmax)+(range(posmax+1)-range(posmax))/2 range(posmax)+(range(posmax+1)-range(posmax))/2],'LineWidth',3);
line([0 k+1],100*[range(posmax)+(range(posmax+1)-range(posmax))/2 range(posmax)+(range(posmax+1)-range(posmax))/2],'LineWidth',3,'color','k');
line([0 k+1],100*[range(posmax)+(range(posmax+1)-range(posmax))/2 range(posmax)+(range(posmax+1)-range(posmax))/2],'LineWidth',3,'color','w','LineStyle','--');

clear all

%%%%%%%%%%%%%%%%%%%%%%%%
% finance 1
load Finance1_PosteriorDraws.mat
if exist('store_z')==0;
    store_z=Z;
    store_q=Q';
    store_gam=sqrt(Gamma2)';
    intq=qq;
    N=0;
end;
Z=store_z(:,N+1:M)';
meanZ=mean(Z);

range=[0:.01:1];
meanZM=zeros(length(range)-1,k);
for j=1:length(range)-1
    Zj=Z(find(store_q(N+1:end)>range(j) & store_q(N+1:end)<range(j+1)),:);
    meanZM(j,:)=mean(Zj);
end

ax1=subplot(3,2,[3]);
imagesc(meanZM)
set(gca,'YDir','Normal','YAxisLocation','right')
colorbar('westoutside')
caxis([0, 1])
colormap(ax1,flipud(colormap(ax1,'hot')))
set(gca,'YTick',[range(1:20:end)*100],'YTickLabel',[range(1:20:end)]);
ylim([0 range(end)*100]);
ylabel('q')
xlabel('coefficients')
title('Finance 1')

[NoDraws]=histcounts([store_q(N+1:end)],range);
[junk posmax]=max(NoDraws);
%line([0 k+1],100*[range(posmax)+(range(posmax+1)-range(posmax))/2 range(posmax)+(range(posmax+1)-range(posmax))/2],'LineWidth',3);
line([0 k+1],100*[range(posmax)+(range(posmax+1)-range(posmax))/2 range(posmax)+(range(posmax+1)-range(posmax))/2],'LineWidth',3,'color','k');
line([0 k+1],100*[range(posmax)+(range(posmax+1)-range(posmax))/2 range(posmax)+(range(posmax+1)-range(posmax))/2],'LineWidth',3,'color','w','LineStyle','--');

clear all

%%%%%%%%%%%%%%%%%%%%%%%%
% finance 2
load Finance2_PosteriorDraws.mat
if exist('store_z')==0;
    store_z=Z;
    store_q=Q';
    store_gam=sqrt(Gamma2)';
    intq=qq;
    N=0;
end;
Z=store_z(:,N+1:M)';
meanZ=mean(Z);

range=[0:.01:1];
meanZM=zeros(length(range)-1,k);
for j=1:length(range)-1
    Zj=Z(find(store_q(N+1:end)>range(j) & store_q(N+1:end)<range(j+1)),:);
    meanZM(j,:)=mean(Zj);
end

ax1=subplot(3,2,[4]);
imagesc(meanZM)
set(gca,'YDir','Normal','YAxisLocation','right')
colorbar('westoutside')
caxis([0, 1])
colormap(ax1,flipud(colormap(ax1,'hot')))
set(gca,'YTick',[range(1:20:end)*100],'YTickLabel',[range(1:20:end)]);
ylim([0 range(end)*100]);
ylabel('q')
xlabel('coefficients')
title('Finance 2')

[NoDraws]=histcounts([store_q(N+1:end)],range);
[junk posmax]=max(NoDraws);
%line([0 k+1],100*[range(posmax)+(range(posmax+1)-range(posmax))/2 range(posmax)+(range(posmax+1)-range(posmax))/2],'LineWidth',3);
line([0 k+1],100*[range(posmax)+(range(posmax+1)-range(posmax))/2 range(posmax)+(range(posmax+1)-range(posmax))/2],'LineWidth',3,'color','k');
line([0 k+1],100*[range(posmax)+(range(posmax+1)-range(posmax))/2 range(posmax)+(range(posmax+1)-range(posmax))/2],'LineWidth',3,'color','w','LineStyle','--');

clear all

%%%%%%%%%%%%%%%%%%%%%%%%
% micro 1
load Micro1_PosteriorDraws.mat
if exist('store_z')==0;
    store_z=Z;
    store_q=Q';
    store_gam=sqrt(Gamma2)';
    intq=qq;
    N=0;
end;
Z=store_z(:,N+1:M)';
meanZ=mean(Z);

range=[0:.01:1];
meanZM=zeros(length(range)-1,k);
for j=1:length(range)-1
    Zj=Z(find(store_q(N+1:end)>range(j) & store_q(N+1:end)<range(j+1)),:);
    meanZM(j,:)=mean(Zj);
end

ax1=subplot(3,2,[5]);
imagesc(meanZM)
set(gca,'YDir','Normal','YAxisLocation','right')
colorbar('westoutside')
caxis([0, 1])
colormap(ax1,flipud(colormap(ax1,'hot')))
set(gca,'YTick',[range(1:20:end)*100],'YTickLabel',[range(1:20:end)]);
ylim([0 range(end)*100]);
ylabel('q')
xlabel('coefficients')
title('Micro 1')

[NoDraws]=histcounts([store_q(N+1:end)],range);
[junk posmax]=max(NoDraws);
%line([0 k+1],100*[range(posmax)+(range(posmax+1)-range(posmax))/2 range(posmax)+(range(posmax+1)-range(posmax))/2],'LineWidth',3);
line([0 k+1],100*[range(posmax)+(range(posmax+1)-range(posmax))/2 range(posmax)+(range(posmax+1)-range(posmax))/2],'LineWidth',3,'color','k');
line([0 k+1],100*[range(posmax)+(range(posmax+1)-range(posmax))/2 range(posmax)+(range(posmax+1)-range(posmax))/2],'LineWidth',3,'color','w','LineStyle','--');

clear all

%%%%%%%%%%%%%%%%%%%%%%%%
% micro 2
load Micro2_PosteriorDraws.mat
if exist('store_z')==0;
    store_z=Z;
    store_q=Q';
    store_gam=sqrt(Gamma2)';
    intq=qq;
    N=0;
end;
Z=store_z(:,N+1:M)';
meanZ=mean(Z);

range=[0:.01:1];
meanZM=zeros(length(range)-1,k);
for j=1:length(range)-1
    Zj=Z(find(store_q(N+1:end)>range(j) & store_q(N+1:end)<range(j+1)),:);
    meanZM(j,:)=mean(Zj);
end

ax1=subplot(3,2,[6]);
imagesc(meanZM)
set(gca,'YDir','Normal','YAxisLocation','right')
colorbar('westoutside')
caxis([0, 1])
colormap(ax1,flipud(colormap(ax1,'hot')))
set(gca,'YTick',[range(1:20:end)*100],'YTickLabel',[range(1:20:end)]);
ylim([0 range(end)*100]);
ylabel('q')
xlabel('coefficients')

[NoDraws]=histcounts([store_q(N+1:end)],range);
[junk posmax]=max(NoDraws);
%line([0 k+1],100*[range(posmax)+(range(posmax+1)-range(posmax))/2 range(posmax)+(range(posmax+1)-range(posmax))/2],'LineWidth',3);
line([0 k+1],100*[range(posmax)+(range(posmax+1)-range(posmax))/2 range(posmax)+(range(posmax+1)-range(posmax))/2],'LineWidth',3,'color','k');
line([0 k+1],100*[range(posmax)+(range(posmax+1)-range(posmax))/2 range(posmax)+(range(posmax+1)-range(posmax))/2],'LineWidth',3,'color','w','LineStyle','--');

title('Micro 2')