close all
clear all

figure('Position', [0, 400, 800, 800]); 

% macro 1
load ../Estimation/EstimationResults/GLPdraws/Macro1_PosteriorDraws; % loading the posterior draws used in the paper
%load ../Estimation/EstimationResults/NEWdraws/Macro1_PosteriorDraws; % loading the posterior draws obtained using a new run of the estimation codes
edges=-.5:1:k+.5;   % these are the edges of the interval (which is centered on .01, .02, etc...)
intSize=0:1:k;
ModelSize=sum(store_z(:,N+1:end))';
subplot(3,2,[1]); ff=histogram(ModelSize,edges,'Normalization','pdf');
vvv=ff.Values;
plot(intSize,(log(1/max(ff.Values).*ff.Values)),'LineWidth',3)
line([0 k],T*[0+log(1/max(vvv))/T-log(k)/T 0+log(1/max(vvv))/T-log(k)/T],'Color','red','LineWidth',1.5,'LineStyle','--');
xlim([0 k])
xlabel('model size')
title('Macro 1')
grid

load ../Forecasts/BMAandSS/BMAandSSResults/GLPforecasts/Macro1_45CV_1000K.mat; % loading the forecasting results used in the paper
%load ../Forecasts/BMAandSS/BMAandSSResults/NEWforecasts/Macro1_45CV_1000K.mat; % loading the forecasting results obtained using a new run of the forecasting codes
hold on
lps=mean(Mscore0);
lps1=mean(Mscore1);
line([0 mean(NEWMAXS(:,1))],T*[0+log(1/max(vvv))/T+lps(1)-lps(3)-log(k)/T 0+log(1/max(vvv))/T+lps(1)-lps(3)-log(k)/T],'Color','red','LineWidth',2,'LineStyle',':');
line([0 mean(NEWMAXS(:,2))],T*[0+log(1/max(vvv))/T+lps(2)-lps(3)-log(k)/T 0+log(1/max(vvv))/T+lps(2)-lps(3)-log(k)/T],'Color','red','LineWidth',1.5,'LineStyle','-.');
plot([k],T*[0+log(1/max(vvv))/T+lps1(4)-lps(3)-log(k)/T],'r*','LineWidth',2);
clear all


% macro 2
load ../Estimation/EstimationResults/GLPdraws/Macro2_PosteriorDraws; % loading the posterior draws used in the paper
%load ../Estimation/EstimationResults/NEWdraws/Macro2_PosteriorDraws; % loading the posterior draws obtained using a new run of the estimation codes
edges=-.5:1:k+.5;   % these are the edges of the interval (which is centered on .01, .02, etc...)
intSize=0:1:k;
ModelSize=sum(store_z(:,N+1:end))';
subplot(3,2,[2]); ff=histogram(ModelSize,edges,'Normalization','pdf');
vvv=ff.Values;
plot(intSize,T*(log(1/max(ff.Values).*ff.Values)/T),'LineWidth',3)
line([0 k],T*[0+log(1/max(vvv))/T-log(k)/T 0+log(1/max(vvv))/T-log(k)/T],'Color','red','LineWidth',1.5,'LineStyle','--');
xlim([0 k])
xlabel('model size')
title('Macro 2')
grid

load ../Forecasts/BMAandSS/BMAandSSResults/GLPforecasts/Macro2_100CV_1000K.mat; % loading the forecasting results used in the paper
%load ../Forecasts/BMAandSS/BMAandSSResults/NEWforecasts/Macro2_100CV_1000K.mat; % loading the forecasting results obtained using a new run of the forecasting codes
hold on
lps=mean(Mscore0);
lps1=mean(Mscore1);
line([0 mean(NEWMAXS(:,1))],T*[0+log(1/max(vvv))/T+lps(1)-lps(3)-log(k)/T 0+log(1/max(vvv))/T+lps(1)-lps(3)-log(k)/T],'Color','red','LineWidth',2,'LineStyle',':');
line([0 mean(NEWMAXS(:,2))],T*[0+log(1/max(vvv))/T+lps(2)-lps(3)-log(k)/T 0+log(1/max(vvv))/T+lps(2)-lps(3)-log(k)/T],'Color','red','LineWidth',1.5,'LineStyle','-.');
plot([k],T*[0+log(1/max(vvv))/T+lps1(4)-lps(3)-log(k)/T],'r*','LineWidth',2);
clear all


% Finance 1
load ../Estimation/EstimationResults/GLPdraws/Finance1_PosteriorDraws; % loading the posterior draws used in the paper
%load ../Estimation/EstimationResults/NEWdraws/Finance1_PosteriorDraws; % loading the posterior draws obtained using a new run of the estimation codes
edges=-.5:1:k+.5;   % these are the edges of the interval (which is centered on .01, .02, etc...)
intSize=0:1:k;
ModelSize=sum(store_z(:,N+1:end))';
subplot(3,2,[3]); ff=histogram(ModelSize,edges,'Normalization','pdf');
vvv=ff.Values;
plot(intSize,T*(log(1/max(ff.Values).*ff.Values)/T),'LineWidth',3)
line([0 k],T*[0+log(1/max(vvv))/T-log(k)/T 0+log(1/max(vvv))/T-log(k)/T],'Color','red','LineWidth',1.5,'LineStyle','--');
xlim([0 k])
xlabel('model size')
title('Finance 1')
grid


load ../Forecasts/BMAandSS/BMAandSSResults/GLPforecasts/Finance1_51CV_1000K.mat; % loading the forecasting results used in the paper
%load ../Forecasts/BMAandSS/BMAandSSResults/NEWforecasts/Finance1_51CV_1000K.mat; % loading the forecasting results obtained using a new run of the forecasting codes
hold on
lps=mean(Mscore0);
lps1=mean(Mscore1);
line([0 mean(NEWMAXS(:,1))],T*[0+log(1/max(vvv))/T+lps(1)-lps(3)-log(k)/T 0+log(1/max(vvv))/T+lps(1)-lps(3)-log(k)/T],'Color','red','LineWidth',2,'LineStyle',':');
line([0 mean(NEWMAXS(:,2))],T*[0+log(1/max(vvv))/T+lps(2)-lps(3)-log(k)/T 0+log(1/max(vvv))/T+lps(2)-lps(3)-log(k)/T],'Color','red','LineWidth',1.5,'LineStyle','-.');
plot([k],T*[0+log(1/max(vvv))/T+lps1(4)-lps(3)-log(k)/T],'r*','LineWidth',2);
clear all


% finance 2
load ../Estimation/EstimationResults/GLPdraws/Finance2_PosteriorDraws; % loading the posterior draws used in the paper
%load ../Estimation/EstimationResults/NEWdraws/Finance2_PosteriorDraws; % loading the posterior draws obtained using a new run of the estimation codes
edges=-.5:1:k+.5;   % these are the edges of the interval (which is centered on .01, .02, etc...)
intSize=0:1:k;
ModelSize=sum(store_z(:,N+1:end))';
subplot(3,2,[4]); ff=histogram(ModelSize,edges,'Normalization','pdf');
vvv=ff.Values;
plot(intSize,T*(log(1/max(ff.Values).*ff.Values)/T),'LineWidth',3)
line([0 k],T*[0+log(1/max(vvv))/T-log(k)/T 0+log(1/max(vvv))/T-log(k)/T],'Color','red','LineWidth',1.5,'LineStyle','--');
xlim([0 k])
xlabel('model size')
title('Finance 2')
grid


load ../Forecasts/BMAandSS/BMAandSSResults/GLPforecasts/Finance2_40CV_1000K.mat; % loading the forecasting results used in the paper
%load ../Forecasts/BMAandSS/BMAandSSResults/NEWforecasts/Finance2_40CV_1000K.mat; % loading the forecasting results obtained using a new run of the forecasting codes
hold on
lps=mean(Mscore0);
lps1=mean(Mscore1);
% line([0 mean(NEWMAXS(:,1))],T*[0+log(1/max(vvv))/T+lps(1)-lps(3)-log(k)/T 0+log(1/max(vvv))/T+lps(1)-lps(3)-log(k)/T],'Color','red','LineWidth',2,'LineStyle',':');
% line([0 mean(NEWMAXS(:,2))],T*[0+log(1/max(vvv))/T+lps(2)-lps(3)-log(k)/T 0+log(1/max(vvv))/T+lps(2)-lps(3)-log(k)/T],'Color','red','LineWidth',1.5,'LineStyle','-.');
%%%%%%%%%%%%%%%%%%
aux5=T*[0+log(1/max(vvv))/T+lps(1)-lps(3)-log(k)/T];
auxnew5=max([aux5 -15]);
aux10=T*[0+log(1/max(vvv))/T+lps(2)-lps(3)-log(k)/T];
auxnew10=max([aux10 -15]);
line([0 mean(NEWMAXS(:,1))],[auxnew5 auxnew5],'Color','red','LineWidth',2,'LineStyle',':');
line([0 mean(NEWMAXS(:,2))],[auxnew10 auxnew10],'Color','red','LineWidth',1.5,'LineStyle','-.');
set(gca, 'YTick', unique([-13.5, get(gca, 'YTick')]));
if auxnew5<=-15; get(gca); auxtick=yticklabels; auxtick(1)={[round(aux5)]}; set(gca,'YTickLabel',auxtick); end
if auxnew10<=-15; get(gca); auxtick=yticklabels; auxtick(1)={[round(aux10)]}; set(gca,'YTickLabel',auxtick); end
get(gca); auxtick=yticklabels; auxtick(2)={['//']}; set(gca,'YTickLabel',auxtick);
%%%%%%%%%%%%%%%%%%
plot([k],T*[0+log(1/max(vvv))/T+lps1(4)-lps(3)-log(k)/T],'r*','LineWidth',2);
clear all


% macro 2
load ../Estimation/EstimationResults/GLPdraws/Micro1_PosteriorDraws; % loading the posterior draws used in the paper
%load ../Estimation/EstimationResults/NEWdraws/Micro1_PosteriorDraws; % loading the posterior draws obtained using a new run of the estimation codes
edges=-.5:1:k+.5;   % these are the edges of the interval (which is centered on .01, .02, etc...)
intSize=0:1:k;
ModelSize=sum(store_z(:,N+1:end))';
subplot(3,2,[5]); ff=histogram(ModelSize,edges,'Normalization','pdf');
vvv=ff.Values;
plot(intSize,T*(log(1/max(ff.Values).*ff.Values)/T),'LineWidth',3)
line([0 k],T*[0+log(1/max(vvv))/T-log(k)/T 0+log(1/max(vvv))/T-log(k)/T],'Color','red','LineWidth',1.5,'LineStyle','--');
xlim([0 k])
xlabel('model size')
title('Micro 1')
grid


load ../Forecasts/BMAandSS/BMAandSSResults/GLPforecasts/Micro1_104CV_1000K.mat; % loading the forecasting results used in the paper
%load ../Forecasts/BMAandSS/BMAandSSResults/NEWforecasts/Micro1_104CV_1000K.mat; % loading the forecasting results obtained using a new run of the forecasting codes
hold on
lps=mean(Mscore0);
lps1=mean(Mscore1);
line([0 mean(NEWMAXS(:,1))],T*[0+log(1/max(vvv))/T+lps(1)-lps(3)-log(k)/T 0+log(1/max(vvv))/T+lps(1)-lps(3)-log(k)/T],'Color','red','LineWidth',2,'LineStyle',':');
line([0 mean(NEWMAXS(:,2))],T*[0+log(1/max(vvv))/T+lps(2)-lps(3)-log(k)/T 0+log(1/max(vvv))/T+lps(2)-lps(3)-log(k)/T],'Color','red','LineWidth',1.5,'LineStyle','-.');
% plot([k],T*[0+log(1/max(vvv))/T+lps1(4)-lps(3)-log(k)/T],'r*','LineWidth',2);
%%%%%%%%%%%%%%%%%%
aux=T*[0+log(1/max(vvv))/T+lps1(4)-lps(3)-log(k)/T];
auxnew=max([aux -15]);
plot([k],auxnew,'r*','LineWidth',2);
set(gca, 'YTick', unique([-13.5, get(gca, 'YTick')]));
if auxnew<=-15; get(gca); auxtick=yticklabels; auxtick(1)={[round(aux)]}; set(gca,'YTickLabel',auxtick); end
get(gca); auxtick=yticklabels; auxtick(2)={['//']}; set(gca,'YTickLabel',auxtick);
%%%%%%%%%%%%%%%%%%
clear all


% macro 2
load ../Estimation/EstimationResults/GLPdraws/Micro2_PosteriorDraws; % loading the posterior draws used in the paper
%load ../Estimation/EstimationResults/NEWdraws/Micro2_PosteriorDraws; % loading the posterior draws obtained using a new run of the estimation codes
edges=-.5:1:k+.5;   % these are the edges of the interval (which is centered on .01, .02, etc...)
intSize=0:1:k;
ModelSize=sum(store_z(:,N+1:end))';
subplot(3,2,[6]); ff=histogram(ModelSize,edges,'Normalization','pdf');
vvv=ff.Values;
plot(intSize,T*(log(1/max(ff.Values).*ff.Values)/T),'LineWidth',3)
line([0 k],T*[0+log(1/max(vvv))/T-log(k)/T 0+log(1/max(vvv))/T-log(k)/T],'Color','red','LineWidth',1.5,'LineStyle','--');
xlim([0 k])
xlabel('model size')
title('Micro 2')
grid


load ../Forecasts/BMAandSS/BMAandSSResults/GLPforecasts/Micro2_100CV_1000K.mat; % loading the forecasting results used in the paper
%load ../Forecasts/BMAandSS/BMAandSSResults/NEWforecasts/Micro2_100CV_1000K.mat; % loading the forecasting results obtained using a new run of the forecasting codes
hold on
lps=mean(Mscore0);
lps1=mean(Mscore1);
line([0 mean(NEWMAXS(:,1))],T*[0+log(1/max(vvv))/T+lps(1)-lps(3)-log(k)/T 0+log(1/max(vvv))/T+lps(1)-lps(3)-log(k)/T],'Color','red','LineWidth',2,'LineStyle',':');
line([0 mean(NEWMAXS(:,2))],T*[0+log(1/max(vvv))/T+lps(2)-lps(3)-log(k)/T 0+log(1/max(vvv))/T+lps(2)-lps(3)-log(k)/T],'Color','red','LineWidth',1.5,'LineStyle','-.');
plot([k],T*[0+log(1/max(vvv))/T+lps1(4)-lps(3)-log(k)/T],'r*','LineWidth',2);
legend('posterior-implied','BMA-all, out of sample','BMA-5 out of sample','BMA-10 out of sample','SS-k out of sample','Location','sw')
clear all

for ii=1:6
    subplot(3,2,ii); ylim([-15 2]);
end