close all
clear all

cd ../Forecasts/BMAandSS/BMAandSSResults/GLPforecasts; % This is the folder containing the forecasting results used in the paper
%cd ../Forecasts/BMAandSS/BMAandSSResults/NEWforecasts; % This is the folder containing the forecasting results obtained using a new run of the forecasting codes

DLPS=zeros(6,3);
SMSFE=zeros(6,3);

load Macro1_45CV_1000K.mat
lps=mean(Mscore0);
lps1=mean(Mscore1);
DLPS(1,:)=[lps(1)-lps(3) lps(2)-lps(3) lps1(4)-lps(3)];
mse=mean(SQdev0);
mse1=mean(SQdev1);
DMSE(1,:)=[mse(1)-mse(3) mse(2)-mse(3) mse1(4)-mse(3)];


load Macro2_100CV_1000K.mat
lps=mean(Mscore0);
lps1=mean(Mscore1);
DLPS(2,:)=[lps(1)-lps(3) lps(2)-lps(3) lps1(4)-lps(3)];
mse=mean(SQdev0);
mse1=mean(SQdev1);
DMSE(2,:)=[mse(1)-mse(3) mse(2)-mse(3) mse1(4)-mse(3)];


load Finance1_51CV_1000K.mat
lps=mean(Mscore0);
lps1=mean(Mscore1);
DLPS(3,:)=[lps(1)-lps(3) lps(2)-lps(3) lps1(4)-lps(3)];
mse=mean(SQdev0);
mse1=mean(SQdev1);
DMSE(3,:)=[mse(1)-mse(3) mse(2)-mse(3) mse1(4)-mse(3)];


load Finance2_40CV_1000K.mat
lps=mean(Mscore0);
lps1=mean(Mscore1);
DLPS(4,:)=[lps(1)-lps(3) lps(2)-lps(3) lps1(4)-lps(3)];
mse=mean(SQdev0);
mse1=mean(SQdev1);
DMSE(4,:)=[mse(1)-mse(3) mse(2)-mse(3) mse1(4)-mse(3)];

load Micro1_104CV_1000K.mat
lps=mean(Mscore0);
lps1=mean(Mscore1);
DLPS(5,:)=[lps(1)-lps(3) lps(2)-lps(3) lps1(4)-lps(3)];
mse=mean(SQdev0);
mse1=mean(SQdev1);
DMSE(5,:)=[mse(1)-mse(3) mse(2)-mse(3) mse1(4)-mse(3)];


load Micro2_100CV_1000K.mat
lps=mean(Mscore0);
lps1=mean(Mscore1);
DLPS(6,:)=[lps(1)-lps(3) lps(2)-lps(3) lps1(4)-lps(3)];
mse=mean(SQdev0);
mse1=mean(SQdev1);
DMSE(6,:)=[mse(1)-mse(3) mse(2)-mse(3) mse1(4)-mse(3)];

%%%%%%%%%%%%%%%%%%%%%%%
% log predictive scores
figure('Position', [0, 400, 800, 400]); 

auxmse=DMSE(5,end);
auxlps=DLPS(5,end);
DMSE(5,end)=0.2;
DLPS(5,end)=-0.07;

for jj=[1 2 3 4 5 6]
    if jj==1;
        scatter(DMSE(jj,:),DLPS(jj,:),60,'o','filled','LineWidth',2); hold on
    elseif jj==2
        scatter(DMSE(jj,:),DLPS(jj,:),40,'o','LineWidth',2); hold on
    elseif jj==3
        scatter(DMSE(jj,:),DLPS(jj,:),100,'h','filled','LineWidth',1); hold on
    elseif jj==4
        scatter(DMSE(jj,:),DLPS(jj,:),80,'s','filled','LineWidth',1); hold on
    elseif jj==5
        scatter(DMSE(jj,:),DLPS(jj,:),60,'d','filled','LineWidth',1); hold on
    elseif jj==6
        scatter(DMSE(jj,:),DLPS(jj,:),60,'v','filled','LineWidth',1); hold on
    end
end
grid
legend('Macro 1','Macro 2','Finance 1','Finance 2','Micro 1','Micro 2')
xlim([-.1 .22])
ylim([-.075 .015])
xlabel('mean squared forecast error (in deviation from BMA-all)')
ylabel('average log-predictive score (in devation from BMA-all)')

get(gca); auxtick=yticklabels; auxtick(2)={['//']}; auxtick(1)={[round(auxlps,2)]}; set(gca,'YTickLabel',auxtick);
get(gca); auxtick=xticklabels; auxtick(end-1)={['//']}; auxtick(end)={[round(auxmse,2)]}; set(gca,'XTickLabel',auxtick);
