close all
clear all

folder='GLPforecasts/'; % This is the folder containing the forecasting results used in the paper
% folder='NEWforecasts/'; % This is the folder containing the forecasting results obtained using a new run of the forecasting codes

colorSSbma=[1 0 0];
colorSSbmafix=[1 .5 0];
colorSS=[1 .75 0];
colorPL=[0 0 1];
colorL=[.3 .3 .3];
colorSBR=[0 .75 0];

fig1=figure(1)
set(fig1,'Position', [0, 400, 800, 800]); %800 instead of 1100 for paper

makesubplot('Macro1',45,1000,'lps',100,-100,1,folder)
makesubplot('Macro2',100,1000,'lps',100,-100,2,folder)
makesubplot('Finance1',51,1000,'lps',100,-100,3,folder)
makesubplot('Finance2',40,1000,'lps',100,-100,4,folder)
makesubplot('Micro1',104,1000,'lps',100,-100,5,folder)
makesubplot('Micro2',100,1000,'lps',2.5,-3.5,6,folder)


fig2=figure(2)
set(fig2,'Position', [0, 400, 800, 800]); %800 instead of 1100 for paper

makesubplot('Macro1',45,1000,'mse',100,-100,1,folder)
makesubplot('Macro2',100,1000,'mse',100,-100,2,folder)
makesubplot('Finance1',51,1000,'mse',100,-100,3,folder)
makesubplot('Finance2',40,1000,'mse',100,-100,4,folder)
makesubplot('Micro1',104,1000,'mse',100,-100,5,folder)
makesubplot('Micro2',100,1000,'mse',2.5,-3.5,6,folder)



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function makesubplot(app,nCV,ndraws,variable,limitmse,limitlps,nsp,folder)

eval(['load ../Forecasts/BMAandSS/BMAandSSResults/',convertStringsToChars(folder),convertStringsToChars(app),'_',num2str(nCV),'CV_',num2str(ndraws),'K'])

msess=mean(SQdev0(:,3)); msess=[msess mean(SQdev0(:,[1 2])) mean(SQdev1(:,[1 2 4]))];
lpsss=mean(Mscore0(:,3)); lpsss=[lpsss mean(Mscore0(:,[1 2])) mean(Mscore1(:,[1 2 4]))];

eval(['load ../Forecasts/PostLasso/PostLassoResults/',convertStringsToChars(folder),'PostLassoFcstGauss',convertStringsToChars(app)])
msepl=[mean(SQdev2(:,[1 2 3 5 6 7]))]; msepl(msepl>=limitmse|msepl==0)=limitmse;
lpspl=[mean(Mscore2(:,[1 2 3 5 6 7]))]; lpspl(lpspl<=limitlps|lpspl==0)=limitlps;

eval(['load ../Forecasts/Lasso/LassoResults/',convertStringsToChars(folder),'LassoFcstGauss',convertStringsToChars(app)])
msel=[mean(SQdev2(:,[1 2 3 5 6 7]))]; msel(msel>=limitmse|msel==0)=limitmse;
lpsl=[mean(Mscore2(:,[1 2 3 5 6 7]))]; lpsl(lpsl<=limitlps|lpsl==0)=limitlps;

eval(['load ../Forecasts/SBR/SBRResults/',convertStringsToChars(folder),'SBRFcst',convertStringsToChars(app)])
msesbr=[mean(SQdev2(:,1:5))]; msesbr(msesbr>=limitmse|msesbr==0)=limitmse;
lpssbr=[mean(Mscore2(:,1:5))]; lpssbr(lpssbr<=limitlps|lpssbr==0)=limitlps;

eval(['load ../Forecasts/TBFMS/TBFMSResults/',convertStringsToChars(folder),'TBFMSFcst',convertStringsToChars(app)])
msetbfms=[mean(SQdev2(:,1:4))]; msetbfms(msetbfms>=limitmse|msetbfms==0)=limitmse;
lpstbfms=[mean(Mscore2(:,1:4))]; lpstbfms(lpstbfms<=limitlps|lpstbfms==0)=limitlps;

%labelsss={'bma','bma-5','bma-10','5','10','k'};
labelsss={'all','5','10','5','10','k'};
labelspl={'5','10','asy','cv2','cv5','cv10'};
labelsl={'5','10','asy','cv2','cv5','cv10'};
labelssbr={'5','10','cv2','cv5','cv10'};
labelstbfms={'I','II','III','IV'};

if variable=='lps';
    lps=[lpsss(1:3) lpspl lpsl lpssbr lpstbfms lpsss(4:6)];
elseif variable=='mse';
    lps=-[msess(1:3) msepl msel msesbr msetbfms msess(4:6)];
end
labels=[labelsss(1:3) labelspl labelsl labelssbr labelstbfms labelsss(4:6)];
Nmodels=length(lps);

% LPS
%fig1=figure(1)
sp=subplot(3,2,nsp);

%radians=pi*[.5:-2/Nmodels:-1.5+2/Nmodels];
radians=pi*[.425:-1.925/Nmodels:-1.5+1.925/Nmodels];

degrees=radians*180/pi; degrees(degrees<0)=degrees(degrees<0)+360;
ps=polarscatter(radians(2:end),lps(2:end),'o','filled'); hold on
ps=polarscatter(radians(1),lps(1),100,'h','filled','r','LineWidth',1);

dfa=abs(max(lps)-min(lps))/10;

ax=gca;
minax=min(lps)-.5*dfa; if nsp==1 minax=min(lps)-2*dfa; elseif nsp==6; minax=min(lps)-4*dfa; end
ax.RLim=[minax max(lps)+dfa];
ax.ThetaTick = sort([mean(degrees(3:4)) mean(degrees(9:10)) mean(degrees(15:16)) mean(degrees(20:21)) mean(degrees(24:25)) mean(degrees([1 end]))]);
ax.ThetaTick(2)=90;
ax.ThetaTickLabel=[];
ax.GridAlpha=1;
ax.RAxisLocation = 89.9;
ax.RTick=flip([lps(1):-(lps(1)-minax)/3:minax+(lps(1)-minax)/3]);
ax.RTickLabel=round(ax.RTick,2);
ax.GridLineStyle=':';

degrees_forplot=degrees;
degrees_forplot(degrees_forplot>90 & degrees_forplot<270)=degrees_forplot(degrees_forplot>90 & degrees_forplot<270)-180;
ttt=text(radians(1),lps(1)+2.5*dfa,labels(1),'FontSize',10,'rotation',degrees_forplot(1),'HorizontalAlignment','right','FontWeight','bold','FontSize',12);
for i=2:Nmodels
    text(radians(i),lps(i)+dfa/2*(radians(i)<-1.4)-dfa/2*(radians(i)>-1.4),...
        labels(i),'FontSize',10,'rotation',degrees_forplot(i),'HorizontalAlignment','right');
end

if nsp==1
    ax.Position=[0 2/3+0.0167 0.5 0.3];
elseif nsp==2
    ax.Position=[0.5 2/3+0.0167 0.5 0.3];
elseif nsp==3
    ax.Position=[0 1/3+0.0167 0.5 0.3];
elseif nsp==4
    ax.Position=[0.5 1/3+0.0167 0.5 0.3];
elseif nsp==5
    ax.Position=[0 0.0167 0.5 0.3];
elseif nsp==6
    ax.Position=[0.5 0.0167 0.5 0.3];
end

title(convertStringsToChars([app(1:end-1),' ',app(end)]),'Fontsize',12)
if nsp==1 || nsp==3 || nsp==5
    ax.TitleHorizontalAlignment = 'left';
else
    ax.TitleHorizontalAlignment = 'right';
end

%text(mean(radians(1:3)),max(lps),'BMA','rotation',mean(degrees_forplot(1:3))-90)
text(pi*mean(degrees(1:2))/180,max(lps)+2*dfa,'BMA','rotation',mean(degrees_forplot(1:2))-95);
text(mean(radians(6:7)),max(lps)+2*dfa,'PL','rotation',mean(degrees_forplot(6:7))+270);
text(mean(radians(12:13)),max(lps)+2*dfa,'L','rotation',mean(degrees_forplot(12:13))-270);
text(mean(radians(18)),max(lps)+2*dfa,'SBR','rotation',mean(degrees_forplot(18))-85);
text(mean(radians(22)),max(lps)+2*dfa,'TBFMS','rotation',mean(degrees_forplot(22))-275);
text(mean(radians(26)),max(lps)+2*dfa,'SS','rotation',mean(degrees_forplot(26))-275);

if nsp==6 & variable=='lps'
    ax.RTick(1)=limitlps;
    ax.RTickLabel=[{['<',num2str(limitlps)]} round(ax.RTick(2:end),2)];
end

if variable=='mse'
    ax.RTickLabel=-round(ax.RTick,2);
end


for jj=1:length(ax.ThetaTick)
    if jj~=2
    ax1=polarplot(ax.ThetaTick(jj)*ones(1,2)*pi/180,ax.RLim,'k','LineWidth',.75);
    end
end

end

