clear all;
close all

T     =    200;
k     =    100;
ss    =   [ 5    10  k];
RR2y  =   [.05  .25  .5];
rho   =   0.75

abeta=1;
bbeta=1;
Abeta=1;
Bbeta=1;

M = 110000;
N =  10000;

Nsim = 100;

Bins = [0.005:.01:.995];


CurrSeed=cell(length(ss),length(RR2y),Nsim);
Freq   =  NaN(length(Bins),length(ss),length(RR2y),Nsim);
Pincl  =  NaN(k,length(ss),length(RR2y),Nsim);
Bavg   =  NaN(k,length(ss),length(RR2y),Nsim);                          

parpool(4)

parfor j = 1:Nsim
    disp('------------------')
    disp('------------------')
    disp(['Now running the ',num2str(j),'th simulation'])
    tempCurrSeed=cell(length(ss),length(RR2y));
    tempFreq   = NaN(k,length(ss),length(RR2y));
    tempPincl  = NaN(k,length(ss),length(RR2y));
    tempBavg   = NaN(k,length(ss),length(RR2y));
    
    for js = 1:length(ss)
        s = ss(js);
        for jR2y = 1:length(RR2y)
            R2y = RR2y(jR2y);
            
            % The sparse model
            [y,x,rsim] = SimulMess(T,k,s,R2y,rho);
            tempCurrSeed{js,jR2y} = rsim.seed;
            
            r=SpikeSlabGLP_forSimulationsForecasts(y,x,[],abeta,bbeta,Abeta,Bbeta,M,N,0,1);%0,1 at the end does notcompute the ML
            
            tempFreq(:,js,jR2y) = hist(r.store_q(N+1:M),Bins)'/(M-N);
            tempPincl(:,js,jR2y)= mean(1-r.store_z(:,N+1:M),2);
            tempBavg(:,js,jR2y)= mean(r.store_B(:,N+1:M),2);
            
        end;
    end;
    
    CurrSeed(:,:,j) = tempCurrSeed;
    Freq(:,:,:,j) = tempFreq;
    Pincl(:,:,:,j)=tempPincl;
    Bavg(:,:,:,j)=tempBavg;
    
end

filename = ['SimulMess_sim',num2str(Nsim),'_draws',num2str(round((N-M)/1000)),'K_rho',num2str(round(rho*100))];
resultsDir = '../SimulationsResults/NEWsimulations/';
eval(['save ' resultsDir filename])
